import QtQuick 2.7
import QtQuick.Controls 1.4
import QtQuick.Layouts 1.3

ApplicationWindow {
    visible: true
    width: 640
    height: 480
    title: qsTr("Hello World")

    Component.onCompleted: tabview.add()

    ColumnLayout {
        anchors.fill: parent

        RowLayout {
            Layout.fillWidth: true
            Button {
                text: "Add tab"
                onClicked: tabview.add()
            }
            Button {
                text: "Remove tab"
                onClicked: tabview.remove()
            }
        }

        TabView {
            Layout.fillHeight: true
            Layout.fillWidth: true
            id: tabview

            property int tabnum: 0

            function add() {
                var tab = insertTab(0, "HappyTab" + tabnum, tableDelegate)
                tab.active = true
                currentIndex = 0
                tab.item.model = tableModel
                tabnum++
            }

            function remove() {
                removeTab(currentIndex)
            }
        }
    }

    ListModel {
        id: tableModel

        ListElement {time: 100; msg: "First line"}
        ListElement {time: 200; msg: "Second line"}
        ListElement {time: 300; msg: "Third line"}
        ListElement {time: 400; msg: "Fourth line"}
        ListElement {time: 500; msg: "Fifth line"}
        ListElement {time: 600; msg: "Sixth line"}
    }

    Component {
        id: tableDelegate

        Rectangle {
            property alias model: table.model
            anchors.fill: parent

            TableView {
                id: table
                anchors.fill: parent
                backgroundVisible: true
                selectionMode: SelectionMode.ContiguousSelection
                frameVisible: false
                verticalScrollBarPolicy: Qt.ScrollBarAsNeeded

                TableViewColumn {
                    id: cTime
                    role: "time"
                    title: qsTr("Time (ms)")
                    width: 100
                    movable: false
                }

                TableViewColumn {
                    id: cMsg
                    role: "msg"
                    title: qsTr("Log message")
                    width: 400
                    movable: false
                }
            }
        }
    }
}
